2010-06-28  Sebastien Pouliot  <sebastien@ximian.com>

	* gendarme.xsl: Update styles to be closer to the current Mono 
	wiki style - which is also closer to Gendarme's logo colors.

2010-06-23  Sebastien Pouliot  <sebastien@ximian.com>

	* TextResultWriter.cs: Apply AvoidRedundancyInMethodNameRule,
	AvoidRepetitiveCallsToPropertiesRule and AvoidLackOfCohesionOfMethodsRule
	* XmlResultWriter.cs: Apply AvoidRedundancyInMethodNameRule

2010-06-05  Sebastien Pouliot  <sebastien@ximian.com>

	* IgnoreFileList.cs: Add 'N' tag to ignore defects on namespaces

2010-06-04  Sebastien Pouliot  <sebastien@ximian.com>

	* IgnoreFileList.cs: Apply AvoidUnnecessarySpecializationRule

2010-05-15  Sebastien Pouliot  <sebastien@ximian.com>

	* IgnoreFileList.cs: Adjust for IIgnoreList changes. Avoid 
	iterating across all analyzed code for each target (single pass).
	Allow * (i.e. all) as a valid value on assembly targets.

2010-05-08  Sebastien Pouliot  <sebastien@ximian.com>

	* ConsoleRunner.cs: Better report warnings if some assembly could
	not be loaded (invalid format, missing .netmodule ...)

2010-05-06  Sebastien Pouliot  <sebastien@ximian.com>

	* ConsoleRunner.cs: Delay showing results after tear down since 
	rules can add defects at this late stage. Show the time required
	to tear down.
	* TextResultWriter.cs: Apply AvoidRepetitiveCallsToPropertiesRule
	on virtual calls 

2010-04-10  Sebastien Pouliot  <sebastien@ximian.com>

	* gendarme.xsl: Add "Mark of the Web" so IE does not popup about 
	security because of our little javascript. Fix bug #594308

2010-01-23  Sebastien Pouliot  <sebastien@ximian.com>

	* Settings.cs: Apply PreferTryParseRule

2010-01-17  Sebastien Pouliot  <sebastien@ximian.com>

	* Options.cs: Update to latest version (2.1)

2009-08-09  Jesse Jones  <jesjones@mindspring.com>

	* ConsoleRunner.cs: Edited the --help text.

2009-07-09  Jesse Jones  <jesjones@mindspring.com>

	* ResultWriter.cs, TextResultWriter.cs, XmlResultWriter.cs, HtmlResultWriter.cs:
	Marked finalize and Dispose methods as threaded.

2009-03-19  Jesse Jones  <jesjones@mindspring.com>

	* ResultWriter.cs: Throws ObjectDisposedException. Protected Dispose(bool)
	from being called twice.

2009-02-19  Cedric Vivier  <cedricv@neonux.com>

	* ConsoleRunner.cs: Show defect count and hint about written reports (if any).

2009-02-12  Cedric Vivier  <cedricv@neonux.com>

	* gendarme.xsl: Use user-configured `sans' font and `em' units instead of
	fixed `pt'. Use a monospace font for code-related text.

2009-02-12  Cedric Vivier  <cedricv@neonux.com>

	* ConsoleRunner.cs: Return 1 to shell if at least one defect has been found.

2009-02-12  Cedric Vivier  <cedricv@neonux.com>

	* ConsoleRunner.cs: Do not show stacktrace and invitation to report a bug
	when there is an IOException (unless VerbosityLevel > 0)

2008-12-23  Cedric Vivier  <cedricv@neonux.com>

	* gendarme.xsl: Usability improvements to the html report.

2008-12-14  Sebastien Pouliot  <sebastien@ximian.com>

	* XmlResultWriter.cs: Let the XmlWriter encode any non-XML compliant
	character found in our XText elements (XLinq does not do that).

2008-12-06  Sebastien Pouliot  <sebastien@ximian.com>

	* TextResultWriter.cs: Big memory reduction in the LINQ query
	by casting the IComparable enum into an IComparable<T> Int32. Even
	bigger now that the query is ordered on two fields. Not sure if
	this has the same effect on MS LINQ or just on Mono.

2008-12-04  Jesse Jones  <jesjones@mindspring.com>

	* ConsoleRunner.cs: Times and copyright info are are no 
	longer written if --quiet was specified.

2008-12-03  Jesse Jones  <jesjones@mindspring.com>

	* ConsoleRunner.cs: --help says "assemblies" instead of
	assembly.

2008-12-01  Jesse Jones  <jesjones@mindspring.com>

	* TextResultWriter.cs: Added a header and a trailer. Sorted 
	defects by severity and then rule name. Include source files. 
	To be consistent with the html "Details: " is now used with 
	the defect text instead of the severity and confidence.

2008-11-22  Jesse Jones  <jesjones@mindspring.com>

	* ConsoleRunner.cs: Tweaked the status write lines to be less noisy.

2008-11-14  Jesse Jones  <jesjones@mindspring.com>

	* Makefile.am: Uses new options.make

2008-11-07  Sebastien Pouliot  <sebastien@ximian.com>

	* TextResultWriter.cs: : Clearly specify [Serializable] on the
	ColorScheme enum (self-test)

2008-11-07  Alan McGovern  <amcgovern@novell.com>

	* gendarme.csproj: Activate makefile integration for all the rules
	projects. Remove the old mdp files as they are no longer needed.

2008-10-21  Sebastien Pouliot  <sebastien@ximian.com>

	* ConsoleRunner.cs: Reset all (loaded) rules as active to be reported
	correctly (wrt XmlResultWriter changes). The console runner only loads
	the rules that will be executed which is why we can activate them all
	before reporting. This is needed because some rules will turn 
	themselves off if they cannot be applied to the current analysis.
	* XmlResultWriter.cs: Only include active rules in the report (since 
	the wizard loads all rules, then turns off the ones not selected).

2008-10-20  Sebastien Pouliot  <sebastien@ximian.com>

	* XmlResultWriter.cs: Fix case where a defect is reported on a
	namespace (which is not bound to a single assembly like other
	metadata objects).

2008-10-12  Sebastien Pouliot  <sebastien@ximian.com>

	* TextResultWriter.cs: Don't initialize fields to default values
	inside constructors (self-test).

2008-09-15  Sebastien Pouliot  <sebastien@ximian.com>

	* ConsoleRunner.cs: Override Initialize to start counting the time
	required to analyze an assembly set. This is required since the 
	new engines are taking their time before the old counter. Switch
	to use Stopwatch instead of DateTime calculations.

2008-08-26  Sebastien Pouliot  <sebastien@ximian.com>

	* ConsoleRunner.cs: Add support for --severity (default to medium+)
	and --confidence (default to normal+). Update help with new options.
	* console.mdp: Update MD project file.

2008-08-25  Sebastien Pouliot  <sebastien@ximian.com>

	* ConsoleRunner.cs: Add support for --limit and add support for
	upcoming rules that will use TearDown.

2008-07-28  Sebastien Pouliot  <sebastien@ximian.com>

	* ConsoleRunner.cs: Better display if no assemblies are specified.
	Don't throw an exception if the assembly name is not valid.
	* Settings.cs: Don't throw an exception of we cannot load a rule 
	assembly.

2008-07-14  Sebastien Pouliot  <sebastien@ximian.com>

	* Settings.cs: Use XmlNode over XmlElement (AvoidUnnecessary
	SpecializationRule) and prefer Assembly.Load to LoadFile
	(AvoidCallingProblematicMethodsRule). 

2008-07-07  Stephane Delcroix  <sdelcroix@novell.com>

	* ConsoleRunner.cs: fix a typo

2008-06-13  Sebastien Pouliot  <sebastien@ximian.com>

	* ConsolerRunner.cs: Add support for --version

2008-06-02  Nestor Salceda  <nestor.salceda@gmail.com>

	* Settings.cs: Parse the applyTo xml attribute and sets the mode to
	the rules.

2008-05-30  Sebastien Pouliot  <sebastien@ximian.com>

	* gendarme.xsl: Make lists and defects collapse/hide to ease 
	results readability.

2008-05-28  Sebastien Pouliot  <sebastien@ximian.com>

	* Helpers.cs: New. Add helper to read files from resources.
	* HtmlResultWriter.cs: Make use of new helper class.
	* Settings.cs: Make use of new helper class.
	* Makefile.am: Update build file.
	* console.mdp: Update MD project file.

2008-05-27  Nestor Salceda  <nestor.salceda@gmail.com>

	* gendarme.xsd: Added the applyTo section for allowing to apply rules to
	different visibility scenarios.

2008-05-25  Sebastien Pouliot  <sebastien@ximian.com>

	* XmlResultWriter.cs: Fix sorting

2008-05-18  Sebastien Pouliot  <sebastien@ximian.com> 

	* console.mdp: Refer to System.Xml.Linq from GAC (not local). 
	Embed gendarme.xsd as a resource (like the Makefile does).
	* Settings.cs: Be more explicit if we don't find gendarme.xsd.

2008-05-18  Sebastien Pouliot  <sebastien@ximian.com>

	* TextResultWriter.cs: Use String.IsNullOrEmpty (self-test)
	* XmlResultWriter.cs: Use String.IsNullOrEmpty (self-test)

2008-05-18  Andres G. Aragoneses <aaragoneses@novell.com> 

	* console.mdp: Fix build.

2008-05-16  Sebastien Pouliot  <sebastien@ximian.com>

	* Settings.cs: Change GetXsdStream to static (self-test).

2008-05-14  Jb Evain  <jbevain@novell.com>

	* XmlResultWriter.cs: use Linq to XML to generate the report.
	* Makefile.am: reference System.Xml.Linq.

2008-05-11  Sebastien Pouliot  <sebastien@ximian.com>

	* XmlResultWriter.cs: Split large Write method.

2008-05-03  Sebastien Pouliot  <sebastien@ximian.com> 

	* TextResultWriter.cs: Split large Write method. Also avoid reporting
	both target and location when they are identical.

2008-05-02  Sebastien Pouliot  <sebastien@ximian.com> 

	* gendarme.csproj: Embed gendarme.xsd as a resource inside the 
	assembly.
	* gendarme.xsd: Fix typos.

2008-04-25  Sebastien Pouliot  <sebastien@ximian.com> 

	* gendarme.xsl: Output HTML as UTF-8

2008-04-21  Nestor Salceda  <nestor.salceda@gmail.com>

	* Settings.cs: Added support for allowing set properties from the XML
	file.

2008-04-15  Nestor Salceda  <nestor.salceda@gmail.com>

	* Makefile.am: Added gendarme.xsd as resource.
	* Settings.cs: Added validation against the xsd file.
	* ConsoleRunner.cs: Report errors produced by the xml configuration
	file.
	* gendarme.xsd: New.  Added the xsd for validate xml configuration
	files.

2008-04-12  Sebastien Pouliot  <sebastien@ximian.com> 

	* ConsoleRunner.cs: Don't annotate assembly.
	* XmlResultWriter.cs: We don't need annotations to get the original
	filename of the assembly.

2008-04-12  Sebastien Pouliot  <sebastien@ximian.com>

	* TextResultWriter.cs: By default add some colors to our display
	private method is used in its declaring type's nested type(s)
	[Cedric Vivier]. Original patch modified to a darker scheme
	(default) for crazy people, like me, with a light background.
	Change default using GENDARME_COLOR=[dark|light|none] gendarme ...

2008-04-06  Sebastien Pouliot  <sebastien@ximian.com>

	* ConsoleRunner.cs: Report all errors using a byte (instead of an
	int) to satisfy ExitCodeIsLimitedOnUnixRule. Display a warning if
	no rule is selected for analysis (instead of displaying nothing).

2008-03-30  Sebastien Pouliot  <sebastien@ximian.com>

	* ConsoleRunner.cs: Fix default value for 'rule_set' so that the 
	--set command line option does not need to be specified (in this 
	case the rule set "default" will be used).
	* Settings.cs: If not specified look for the "rules.xml" file that
	resides with the runner.

2008-03-15  Sebastien Pouliot  <sebastien@ximian.com> 

	* Options.cs: Update to version 0.2.0
	* HtmlResultWriter.cs: Try harder to find the XSLT in the assembly 
	resource files.

2008-03-04  Sebastien Pouliot  <sebastien@ximian.com>

	* HtmlResultWriter.cs, ResultWriter.cs, TextResultWriter.cs,
	XmlResultWriter.cs: Rework IDisposable to reduce duplication.

2008-02-17  Sebastien Pouliot  <sebastien@ximian.com>

	* ConsoleRunner.cs: Split with Settings and add support for ignoring
	defects based on a user supplied list.
	* IgnoreFileList.cs: New. File-based ignore list.
	* Settings.cs: New. Configuration support for runner.
	* console.mdp: Update MonoDevelop project file.
	* Makefile.am: Update build file.

2008-02-16  Sebastien Pouliot  <sebastien@ximian.com> 

	* ConsoleRunner.cs: Handle no arguments. Show correct timing for
	each assembly being processed.
	* XmlResultWriter.cs: Call Dispose (not Close).

2008-02-15  Sebastien Pouliot  <sebastien@ximian.com> 

	* ConsoleRunner.cs: Updated runner for the new framework (still a 
	work in progress).
	* gendarme.xsl: Updated XSLT to match new XML format.
	* HtmlResultWriter.cs: Produce HTML reports using gendarme.xsl and
	the XML writer.
	* Makefile.am: Updated with changes.
	* Options.cs: Jonathan Pryor Getopt::Long-inspired option parsing 
	library for C#
	* ResultWriter.cs: Renamed from IResultWriter. Now an abstract class.
	* TextResultWriter.cs: Updated for display more information.
	* XmlResultWriter.cs: Updated xml format for results.

2008-02-03  Sebastien Pouliot  <sebastien@ximian.com> 

	* gendarme.xsl: Display the correct message (not the first one) for
	each location.

2008-01-12  Sebastien Pouliot  <sebastien@ximian.com> 

	* ConsoleRunner.cs: Start using Gendarme.Console.Writers namespace.
	Change a method to static. 
	* HtmlResultWriter.cs: Use 2.0 XslCompiledTransform (XslTransform 
	being obsolete). Move into Gendarme.Console.Writers namespace.
	* IResultWriter.cs: Move into Gendarme.Console.Writers namespace.
	* TextResultWriter.cs: Move into Gendarme.Console.Writers namespace.
	* XmlResultWriter.cs: Move into Gendarme.Console.Writers namespace.
	* console.mdp: MD removed the "./" before the filenames

2007-11-30  Nestor Salceda  <nestor.salceda@gmail.com>

	* ConsoleRunner.cs: Extracted methods for avoid a long method violation
	from Main.

2007-11-29  Nestor Salceda  <nestor.salceda@gmail.com>

	* ConsoleRunner.cs: Don't ignore methods result (it fails a rule) in the
	self-test.

2007-11-29  Nestor Salceda  <nestor.salceda@gmail.com>

	* ConsoleRunner.cs: Added support for set values for some properties in
	the configuration XML file.

2007-11-21  Sebastien Pouliot  <sebastien@ximian.com>

	* ConsoleRunner.cs: Ensure patterns, like * and ?, works inside the 
	current directory. Return the full path in this case too.

2007-10-08  Sebastien Pouliot  <sebastien@ximian.com>

	* ConsoleRunner.cs: Avoid WriteStaticFieldFromInstanceMethodRule 
	inside runner

2007-10-07  Sebastien Pouliot  <sebastien@ximian.com>

	* console.mdp: Now built with 2.0 rutime.

2006-10-15  Sebastien Pouliot  <sebastien@ximian.com>

	* gendarme.xsl: Create only one new browser-window per rule.

2006-10-09  Sebastien Pouliot  <sebastien@ximian.com>

	* ConsoleRunner.cs: Provide more information with assemblies. Fix some
	typos.
	* gendarme.xsl: Add links to mono-project.com for rules. Fix defects 
	count on assemblies. Add defects count on rules. Ensure all defects 
	are reported (even if the location is unknown). Display more details 
	on where the defect are found (assembly, location).
	* HtmlResultWriter.cs: Update signature for assemblies.
	* IResultWriter.cs: Update signature for assemblies.
	* Makefile.am: Rebuild gendarme.exe if the XSLT file changes.
	* TextResultWriter.cs: Update signature for assemblies.
	* XmlResultWriter.cs: Add fully-qualified assembly names when 
	outputing aasemblies. Add short-name and Uri when outputing rules.
	Both enables more useful HTML reports.

2006-09-28  Sebastien Pouliot  <sebastien@ximian.com>

	* Makefile.am: Adjust EXTRA_DIST to include project files in tarballs.

2006-09-28  Christian Birkl  <christian.birkl@gmail.com>

	* gendarme.csproj: Included ChangeLog
	* XmlResultWriter.cs, TextResultWriter.cs: Migrated untyped IList
	messages collection to typed MessageCollection class.
	  
2006-09-17  Sebastien Pouliot  <sebastien@ximian.com>

	* console.mdp: Update MonoDevelop project file
	* ConsoleRunner.cs: Add new options to the console runner.
	* HtmlResultWriter.cs: New. Output HTML reports using the XML
	output and the new XSL transform.
	* IResultWriter.cs: New. Interface for all reporters. Original code 
	from Christian Birkl adapted/merged with existing code.
	* Makefile.am: Add new files to the build.
	* TextResultWriter.cs: New. Output text reports. Original code from 
	Christian Birkl adapted/merged with existing code.
	* XmlResultWriter.cs: New. Output XML reports. Original code from 
	Christian Birkl adapted/merged with existing code.

2006-09-17  Christian Birkl <christian.birkl@gmail.com>

	* gendarme.xsl: New. XSLT file to transform XML output into HTML.

2006-08-28  Sebastien Pouliot  <sebastien@ximian.com>

	* ConsoleRunner.cs: Fix exception when rules.xml contains XML 
	comments. Patch by Christian Birkl.

2006-07-31  Sebastien Pouliot  <sebastien@ximian.com>

	* console.mdp: New. Project file for MonoDevelop.
	* ConsoleRunner.cs: Adjust header display when Gendarme is compiled 
	from a MD project.

2006-06-13  Sebastien Pouliot  <sebastien@ximian.com>

	* ConsoleRunner.cs: Read the copyright informations from the attribute
	in AssemblyInfo.cs file. Fix NewLineLiteralRule in LoadConfiguration 
	method (self-test).
	* Makefile.am: Added self-test to promote compliance ;-)
